/*
*
*  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
*
*/

package com.honeywell.easytemplating.services;

import com.honeywell.easytemplating.components.BEasyTemplate;
import com.honeywell.easytemplating.util.EasyTemplatingUtils;

import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BComponent;
import javax.baja.sys.BIService;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import java.io.File;

import static com.honeywell.easytemplating.util.EasyTemplatingConst.ET_RT_ETSO_HOME;

/*
 * Created by H352376 on 15/03/2019
 */
@NiagaraProperty(
        name = "easyTemplate",
        type = "BEasyTemplate",
        defaultValue = "new BEasyTemplate()",
        flags = Flags.SUMMARY
)

@NiagaraType
public class BEasyTemplatingService extends BComponent implements BIService {

    /*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
    /*@ $com.honeywell.easytemplating.services.BEasyTemplatingService(2732966031)1.0$ @*/
    /* Generated Wed May 15 15:55:22 BST 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "easyTemplate"
////////////////////////////////////////////////////////////////

    /**
     * Slot for the {@code easyTemplate} property.
     *
     * @see #getEasyTemplate
     * @see #setEasyTemplate
     */
    public static final Property easyTemplate = newProperty(Flags.SUMMARY, new BEasyTemplate(), null);

    /**
     * Get the {@code easyTemplate} property.
     *
     * @see #easyTemplate
     */
    public BEasyTemplate getEasyTemplate() {
        return (BEasyTemplate) get(easyTemplate);
    }

    /**
     * Set the {@code easyTemplate} property.
     *
     * @see #easyTemplate
     */
    public void setEasyTemplate(BEasyTemplate v) {
        set(easyTemplate, v, null);
    }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

    @Override
    public Type getType() {
        return TYPE;
    }

    public static final Type TYPE = Sys.loadType(BEasyTemplatingService.class);

    /*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

    @Override
    public Type[] getServiceTypes() {
        return new Type[]{
                TYPE
        };
    }

    @Override
    public void serviceStarted() throws Exception {
        // service started
        String etsoPath = Sys.getStationHome()+ File.separator + ET_RT_ETSO_HOME;
        File etsoDir = new File(etsoPath);
        EasyTemplatingUtils.setEtsoFilesToReadOnly(etsoDir);
    }

    @Override
    public void serviceStopped() throws Exception {
        // service stopped
    }

}
