/*
*
*  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
*
*/
package com.honeywell.easytemplating.util;

import javax.baja.gx.BColor;
import javax.baja.gx.BInsets;
import javax.baja.naming.SlotPath;
import javax.baja.tag.Id;
import java.io.File;

public final class EasyTemplatingConst {

    public static final String EMPTY = "";
    public static final String SEPERATOR = "/";
    public static final String ET_LINKER = "EasyTemplatingLinker";
    public static final String ET_TAG_PARENT = "n:parent";
    public static final String ET_SLOT_OUT = "out";
    public static final String ET_SLOT_IN2 = "in2";
    public static final String ET_SLOT_IN16 = "in16";

    public static final int ET_CHUNK_ONE = 1;
    public static final int ET_CHUNK_TWO = 2;

    // Easy Templating Linker
    public static final String ET_ERROR_NORELATION = "No parent relation found at root";
    public static final String ET_ERROR_LINK_FAILED = "Could not link to source component :";

    //Easy Templating Utils
    public static final int ET_INDEX_GAP = 2;
    public static final String STATUS_OK = "OK";
    public static final String BASE_SLOT = "station:|slot:/";
    public static final String SLOT = "slot:";
    public static final String BASE_DEPLOY = File.separator + "px" + File.separator + "deploy" + File.separator;
    public static final String WB_BASE_SLOT = "local:|foxs:|station:|slot:/";
    public static final String WB_FILE_BASE_SLOT = "local:|foxs:|";
    public static final String ET_FILE = "file";
    public static final String ET_FILE_OS = "file:/";
    public static final String ET_HISTORY_OS="history:/";
    public static final String ET_VIEW_REQ_EXT  = "|view";
    public static final String ET_POPUP_BINDING = "PopupBinding";
    public static final String ET_BOUNDLABEL_BINDING = "BoundLabelBinding";
    public static final String ET_ANY_BINDING = "Binding";
    public static final String ET_POPUP_BINDING_PREFIX = "file:^px/deploy/";
    public static final String ET_POPUP_BINDING_PREFIX_TEST = "local:|foxs:|file:^px/deploy/";
    public static final String ET_ORD = "ord";
    public static final String ET_VARIABLES = "variables";
    public static final String ET_SIMPLE_OBJ_FILE_EXT = "etso";
    public static final String ET_SIMPLE_OBJ_FILE_EXTE_DOT = ".etso";
    public static final String ET_COMPLEX_OBJ_FILE_EXT = "etco";
    public static final String ET_COMPLEX_OBJ_FILE_EXTE_DOT = ".etco";
    private static final String DOT = ".";
    public static final String ET_PX_FILE_EXT = "px";
    public static final String ET_PX_FILE_DOT_EXT = DOT + "px";
    public static final String ET_PALETTE_FILE_EXT = "palette";
    public static final String ET_VERSION_XML_FILE_EXT = "xml";
    public static final String ET_ETSO_BINDING_STRING = "$(";
    public static final String ET_WB_EMPTY_VARIABLES = "";
    public static final String ET_BINDING_ORD_PREFIX = "$(var)";
    public static final String ET_POPUP_VIEW_IN_POPUP_PX_FILE = "popupView";

    // Easy Templating Generation Helper
    public static final String ET_TEMPLATE_FOLDER = "~shared";
    public static final String ET_TEMPLATE_FOLDER_ORD = "local:|file:" + ET_TEMPLATE_FOLDER;
    public static final String ET_TEMPLATE_VENDOR = "Honeywell";
    public static final String ET_ERROR_INMEM_NTPL = "Could not create in-memory template file";
    public static final String ET_ERROR_ORD_RESOLUTION = "Error resolving ord string: %s";
    public static final String ET_OK_NTPL_CREATION = "Template successfully created";
    public static final String ET_ERROR_NTPL_CREATION = "Easy Templating Error";
    public static final String ET_OK_NTPL_CREATION_W_PARAM = ET_OK_NTPL_CREATION + ": %s";
    public static final String ET_ERROR_NTPL_IO = "I/O error when creating template file";
    public static final String ET_TITLE = "Easy Templating";
    public static final String ET_MAIN_VIEW = "MainView";
    public static final String ET_POPUP_VIEW = "PopupView";
    public static final String ET_ERROR_CREATING_MEMORY_BASED_PX_FILES = "Failed to create memory based PX files";
    public static final String ET_RT_ETSO_HOME = "etsoFiles";
    //Toaster Header colours and types
    public static final int ET_TOAST_ERROR = 0;
    public static final int ET_TOAST_SUCCESS = 1;
    public static final int ET_TOAST_WARNING = 2;


    private static final Id TEMPLATE_FILE_TAG_ID = Id.newId("ntpl:fileName");
    private static final Id TEMPLATE_ROOT_TAG_ID = Id.newId("ntpl:template");
    private static final Id TEMPLATE_VENDOR_TAG_ID = Id.newId("ntpl:vendor");
    private static final Id TEMPLATE_VERSION_TAG_ID = Id.newId("ntpl:version");
    private static final Id TEMPLATE_TITLE_TAG_ID = Id.newId("ntpl:title");
    private static final Id TEMPLATE_DESCRIPTION_TAG_ID = Id.newId("ntpl:desc");
    private static final Id TEMPLATE_UID_TAG_ID = Id.newId("ntpl:id");

    //bog file relation
    public static final Id TEMPLATE_RELATION = Id.newId(ET_TAG_PARENT);

    public static final String ET_ROOT_TAG_NAME = SlotPath.escape(TEMPLATE_ROOT_TAG_ID.getQName());
    public static final String ET_NTPL_FILE_TAG_NAME = SlotPath.escape(TEMPLATE_FILE_TAG_ID.getQName());
    public static final String ET_VENDOR_TAG_NAME = SlotPath.escape(TEMPLATE_VENDOR_TAG_ID.getQName());
    public static final String ET_TITLE_TAG_NAME = SlotPath.escape(TEMPLATE_TITLE_TAG_ID.getQName());
    public static final String ET_VERSION_TAG_NAME = SlotPath.escape(TEMPLATE_VERSION_TAG_ID.getQName());
    public static final String ET_INFO_TAG_NAME = SlotPath.escape(TEMPLATE_DESCRIPTION_TAG_ID.getQName());
    public static final String ET_UID_TAG_NAME = SlotPath.escape(TEMPLATE_UID_TAG_ID.getQName());
    public static final int ET_READONLY_HIDDEN_META = 16389;

    // Easy Templating Utils
    public static final String ET_NEQL_CHARS_QUOTE = "\"";
    public static final String ET_NEQL_CHECK_NAME = "(n:name=";
    public static final String ET_NEQL_CHECK_NAME_OF_POINT = "(n:point and n:name=";
    public static final String ET_NEQL_CHECK_TYPE = " and n:type=";
    public static final String ET_NEQL_CHECK_OR = ") or ";
    private static final String ET_NEQL_CHECK_FOLDER = ET_NEQL_CHARS_QUOTE + "baja:Folder" + ET_NEQL_CHARS_QUOTE;
    public static final String ET_NEQL_CHECK_EMPTY_FOLDERS =
            "((n:type=" + ET_NEQL_CHECK_FOLDER + ") and !(n:child->(n:point or n:type=" + ET_NEQL_CHECK_FOLDER + ")))";
    public static final String ET_NEQL_AND = " and ";

    // Easy Templating Toast (notification UI)
    public static final String ET_TOAST_TITLE_KEY = "title";
    public static final String ET_TOAST_MESSAGE1_KEY = "message1";
    public static final String ET_TOAST_MESSAGE2_KEY = "message2";
    public static final String ET_TOAST_ICON_KEY = "icon";
    public static final String ET_TOAST_TIMEOUT_MS_KEY = "timeoutMs";
    public static final String ET_TOAST_TYPE_KEY = "type";
    public static final String ET_TOAST_ICON_ORD_OK = "module://icons/x16/check.png";
    public static final String ET_TOAST_ICON_ORD_WARNING = "module://icons/x16/warning.png";
    public static final String ET_TOAST_ICON_ORD_ERROR = "module://icons/x16/error.png";
    public static final String ET_TOAST_ICON_ORD_INFO = "module://icons/x16/info.png";
    public static final int ET_TOAST_SHORT_TIMEOUT = 3500;
    public static final int ET_TOAST_LONG_TIMEOUT = 5500;
    public static final double ET_TOAST_TITLE_FONT_SIZE = 15d;
    public static final double ET_TOAST_MESSAGE_FONT_SIZE = 14d;
    public static final BColor ET_TOAST_TITLE_SUCCESS_BG_COLOR = BColor.make(45, 75, 45);
    public static final BColor ET_TOAST_TITLE_WARNING_BG_COLOR = BColor.make(195, 176, 145);
    public static final BColor ET_TOAST_TITLE_ERROR_BG_COLOR = BColor.make(255, 0, 0);
    public static final BColor ET_TOAST_TITLE_FG_COLOR = BColor.ivory;
    public static final BInsets ET_TOAST_TITLE_INSETS = BInsets.make(3, 18, 3, 18);
    public static final BInsets ET_TOAST_MESSAGE_WIDGET_INSETS = BInsets.make(10, 0, 5, 0);

    //SimpleObject
    public static final String ET_OK_ETSO_CREATION = "Simple Object successfully created";
    public static final String ET_ERROR_ETSO_CREATION = "Error when creating .etso file";
    public static final String ET_ETSO_SUCCESS = "File created";
    public static final String ET_ETSO_ERROR = "Error create file";
    public static final String ET_ERROR_NON_PX_FILE_SELECTED = "Selected file is not a PX page";
    public static final String ET_ETSO_PX_TYPE = "file:PxFile";
    public static final String ET_ETSO_DIRECTORY = "^px/etso/";
    public static final String ET_ETSO_BASE_DIRECTORY = "^px/etso";
    public static final String ET_ETSO_DIRECTORY_ORD = "local:|file:^px/etso";
    public static final String ET_DEPLOY_DIRECTORY_ORD = "local:|file:^px/deploy";
    public static final String ET_FILE_DEPLOY_DIRECTORY_ORD = "file:^px/deploy/";
    public static final String ET_DEPLOY_DIRECTORY_MAKE_ORD = "local:|file:^px/deploy";

    //wb component space
    public static final String ET_WB_COMPONENT_SPACE = "local:|foxs:|";
    public static final String ET_WB_LOCAL_SPACE = "local:|";

    //SimpleObject Error messages
    public static final String ET_ETSO_CREATING_DIRECTORY = "Creating etso directory";
    public static final String ET_ETSO_CANT_CREATE_DIRECTORY = "Can't create etso directory";
    public static final String ET_ETSO_RESOLVE_CONTROLPOINT_FAILED = "Resolve BControlPoint failed";
    public static final String ET_ETSO_FILE_CREATION_FAILED = "Simple object .etso file creation failed";
    public static final String ET_ETSO_FILE_EXISTS_OVERWRITE = "File already exists, overwriting: ";

    // EasyTemplating related types
    public static final String ET_EASY_TEMPLATING_BINDING_TYPE = "easyTemplating:EasyTemplatingBinding";
    public static final String ET_EASY_POPUP_BINDING_TYPE = "easyTemplating:EasyPopupBinding";
    public static final String ET_KITPX_POPUP_BINDING_NAME ="PopupBinding";

    // EasyBinding related types
    public static final String ET_EASY_BINDING_WIDGET_TYPE = "easyBinding:EasyBindingWidget";
    public static final String ET_EASY_VALUE_BINDING_TYPE = "easyBinding:EasyValueBinding";
    public static final String ET_EASY_ALARM_BINDING_TYPE = "easyBinding:EasyAlarmBinding";
    public static final String ET_EASY_OVERRIDE_BINDING_TYPE = "easyBinding:EasyOverrideBinding";
    public static final String ET_EASY_HISTORY_POPUP_BINDING="EasyHistoryPopupBinding";

    // honBacnetUtilities related types
    public static final String ET_HON_BACNET_VIRTUAL_PROPERTY_BINDING =
            "honBACnetUtilities:HonBacnetVirtualPropertyBinding";
    public static final String ET_HON_BACNET_HISTORY_BINDING =
            "honBACnetUtilities:HonBacnetHistoryBinding";

    //EasyBinding related types
    public static final String EB_EASYBINDINGWIDGET ="EasyBindingWidget";
    public static final String BOUNDLABEL ="BoundLabel";
    public static final int NUM_TWO=2;
    public static final String VALUEBINDING ="ValueBinding";

    //EasyTemplate related types
    public static final String ET_TOAST_ERR_TITLE = "EasyTemplate.Toast.Error.Title";
    public static final String ET_TEMPLATE_NAME_TEMPLATE_PX = "EasyTemplate.TemplateName.TemplatePx";
    public static final String ET_FILL_FIELDS = "EasyTemplate.Fill.Fields";
    public static final String ET_TEMPLATE_CREATION_ERR = "EasyTemplate.Template.Creation.Error";
    public static final String ET_TEMPLATE_ROOT_ERR = "EasyTemplate.Root.Error";
    public static final String ET_CREATE_IN_MEMORY_TEMPLATE_FILE = "EasyTemplate.Create.InMemory.Template.File";
    private EasyTemplatingConst() {

    }
}