/*
*
*  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
*
*/
package com.honeywell.easytemplating.util;

import java.util.logging.Level;
import java.util.logging.Logger;

public final class EasyTemplatingLogger {

    private EasyTemplatingLogger(){
        //fw required
    }
    /**
     * Fine logging
     */
    public static void fine(String fineMSG){
        LOG.fine(fineMSG);
    }
    /**
     * Info logging
     */
    public static void info(String infoMSG){
        LOG.info(infoMSG);
    }

    /**
     * Error logging
     */
    public static void error(String errorMSG, Throwable throwAble){
        LOG.log(Level.SEVERE, errorMSG, throwAble);
    }

    public static void infoWithException(String errorMSG, Throwable throwAble){
        String logMessage = String.format("%s : %s", errorMSG, throwAble.getMessage());
        LOG.info(logMessage);
    }



    private static final String ET_LOG_NAME = "EasyTemplating";
    public static final Logger LOG = Logger.getLogger(ET_LOG_NAME);
}
